unit FormCenter;

interface

uses
  Windows, Messages, Classes, Controls, StdCtrls, ExtCtrls,
  Forms, SysUtils;

type
   TFormCenter = class(TComponent)
   private
   FParentForm : TForm;
   FMainForm   : TForm;
   FEnabled : Boolean;
   public
   constructor Create(aOwner: TComponent); override;
   Property Parent : TForm Read FParentForm Write FParentForm;
   Property Source : TForm Read FmainForm  Write FMainForm;
   published
   Property Center : Boolean Read FEnabled Write FEnabled;
   Procedure CenterForm;
  end;
   procedure Register;

implementation


constructor TFormCenter.Create(aOwner: TComponent);
begin
  inherited Create(aOwner);
  Center := True;
  Parent := TForm(aOwner);
  Parent.Position := poDesigned;
end;

Procedure TFormCenter.CenterForm;
Var
MW,ML,PW,TL : INTEGER;
MH,MT,PH,TT : INTEGER;
begin
if Center = false then
exit
else
MW := Source.ClientWidth div 2;
ML := Source.Left;
PW := Parent.ClientWidth div 2;

MH := Source.ClientHeight div 2;
MT := Source.Top;
PH := Parent.ClientHeight div 2;

TT := MH + MT - PH;
TL := MW + ML - PW;
With Parent do Begin
  Left := TL;
  Top  := TT;
 End;
End;

procedure Register;
begin
  RegisterComponents('Screaming Art', [TFormCenter]);
end;

end.